Annotated
Date: 2016-12-04

com.fasterxml.jackson.databind.introspect

## Class Annotated

- java.lang.Object
- - com.fasterxml.jackson.databind.introspect.Annotated

- Direct Known Subclasses:
    AnnotatedClass, AnnotatedMember

      public abstract class Annotated
      extends java.lang.Object

  Shared base class used for anything on which annotations (included within a `AnnotationMap`).

- - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `Annotated()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `abstract java.lang.Iterable<java.lang.annotation.Annotation>` | `annotations()` Accessor that can be used to iterate over all the annotations associated with annotated component.
    `abstract boolean` | `equals(java.lang.Object o)`
    `protected abstract AnnotationMap` | `getAllAnnotations()` Internal helper method used to access annotation information; not exposed to developers since instances are mutable.
    `abstract java.lang.reflect.AnnotatedElement` | `getAnnotated()` Method that can be used to find actual JDK element that this instance represents.
    `abstract <A extends java.lang.annotation.Annotation> A` | `getAnnotation(java.lang.Class<A> acls)`
    `java.lang.reflect.Type` | `getGenericType()` Deprecated. Since 2.7 should instead use `getType()`. To be removed from 2.9
    `protected abstract int` | `getModifiers()`
    `abstract java.lang.String` | `getName()`
    `abstract java.lang.Class<?>` | `getRawType()` "Raw" type (type-erased class) of the annotated element; definition of what exactly this means depends on sub-class.
    `abstract JavaType` | `getType()` Full generic type of the annotated element; definition of what exactly this means depends on sub-class.
    `JavaType` | `getType(TypeBindings bogus)` Deprecated. Since 2.7 Use `getType()` instead. To be removed from 2.9
    `abstract boolean` | `hasAnnotation(java.lang.Class<?> acls)`
    `abstract int` | `hashCode()`
    `abstract boolean` | `hasOneOf(java.lang.Class<? extends java.lang.annotation.Annotation>[] annoClasses)`
    `boolean` | `isPublic()`
    `abstract java.lang.String` | `toString()`
    `abstract Annotated` | `withAnnotations(AnnotationMap fallback)` Fluent factory method that will construct a new instance that uses specified instance annotations instead of currently configured ones.
    `Annotated` | `withFallBackAnnotationsFrom(Annotated annotated)` Fluent factory method that will construct a new instance that uses annotations from specified `Annotated` as fallback annotations

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### Annotated

          protected Annotated()

  - ### Method Detail

    - #### getAnnotation

          public abstract <A extends java.lang.annotation.Annotation> A getAnnotation(java.lang.Class<A> acls)

    - #### hasAnnotation

          public abstract boolean hasAnnotation(java.lang.Class<?> acls)

    - #### hasOneOf

          public abstract boolean hasOneOf(java.lang.Class<? extends java.lang.annotation.Annotation>[] annoClasses)

      Since:
        2.7

    - #### withAnnotations

          public abstract Annotated withAnnotations(AnnotationMap fallback)

      Fluent factory method that will construct a new instance that uses specified instance annotations instead of currently configured ones.

    - #### withFallBackAnnotationsFrom

          public final Annotated withFallBackAnnotationsFrom(Annotated annotated)

      Fluent factory method that will construct a new instance that uses annotations from specified `Annotated` as fallback annotations

    - #### getAnnotated

          public abstract java.lang.reflect.AnnotatedElement getAnnotated()

      Method that can be used to find actual JDK element that this instance represents. It is non-null, except for method/constructor parameters which do not have a JDK counterpart.

    - #### getModifiers

          protected abstract int getModifiers()

    - #### isPublic

          public final boolean isPublic()

    - #### getName

          public abstract java.lang.String getName()

    - #### getType

          public abstract JavaType getType()

      Full generic type of the annotated element; definition of what exactly this means depends on sub-class.
      Since:
        2.7

    - #### getType

          @Deprecated
          public final JavaType getType(TypeBindings bogus)

      Deprecated. Since 2.7 Use `getType()` instead. To be removed from 2.9

    - #### getGenericType

          @Deprecated
          public java.lang.reflect.Type getGenericType()

      Deprecated. Since 2.7 should instead use `getType()`. To be removed from 2.9
      JDK declared generic type of the annotated element; definition of what exactly this means depends on sub-class. Note that such type can not be reliably resolved without `TypeResolutionContext`, and as a result use of this method was deprecated in Jackson 2.7: see `getType()` for replacement.

    - #### getRawType

          public abstract java.lang.Class<?> getRawType()

      "Raw" type (type-erased class) of the annotated element; definition of what exactly this means depends on sub-class.

    - #### annotations

          public abstract java.lang.Iterable<java.lang.annotation.Annotation> annotations()

      Accessor that can be used to iterate over all the annotations associated with annotated component.
      Since:
        2.3

    - #### getAllAnnotations

          protected abstract AnnotationMap getAllAnnotations()

      Internal helper method used to access annotation information; not exposed to developers since instances are mutable.

    - #### equals

          public abstract boolean equals(java.lang.Object o)

      Overrides:
        `equals` in class `java.lang.Object`

    - #### hashCode

          public abstract int hashCode()

      Overrides:
        `hashCode` in class `java.lang.Object`

    - #### toString

          public abstract java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`